###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2006 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define cman_major 2
%define cman_minor 0.62

%define my_requires %{_builddir}/my_requires
%define _use_internal_dependency_generator 0

%define buildxen 0

%ifarch i386 x86_64 ia64
%define buildxen 1
%endif

Name: cman
Version: %{cman_major}.%{cman_minor}
Release: 1%{?dist}
License: GPL
Group: System Environment/Base
Summary: cman - The Cluster Manager
#BuildRequires: kernel >= 2.6.16
BuildRequires: glibc-kernheaders
BuildRequires: libxml2-devel
BuildRequires: openais-devel openais

%if %{buildxen}
BuildRequires: nss-devel nspr-devel libvirt-devel xen-libs
#Requires: nss nspr libvirt xen xen-libs
%endif

Conflicts: GFS <= 6.0
Conflicts: GFS-modules
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires: openais
URL: http://sources.redhat.com/cluster/
Source0: %{name}-%{version}.tar.gz
Patch0: cman-2.0.5-libraryfix.patch
Patch1: cman-makefix.patch
Patch2: cman-plocktemp.patch
Patch3: cman-2.0.14-defaultrun.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
cman - The Cluster Manager

%package devel
Group: Development/Libraries
Summary: cman cluster manager development package
Requires: cman = %{version}-%{release}

%description devel
cman - The Cluster Manager

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .libraryfix
%patch1 -p1 -b .makefix
%patch2 -p1 -b .plock
%patch3 -p1 -b .defaultrun

%{__cat} <<EOF >%{my_requires}
#!/bin/sh
%{__find_requires} | grep -v '^libvirt'
exit 0
EOF
chmod +x %{my_requires}
%define __find_requires %{my_requires}

%build
TOPDIR=`pwd`

cd ccs ; ./configure --libdir=%{_libdir}; cd ..
cd dlm ; ./configure --kernel_src=/usr/ --libdir=%{_libdir}; cd ..
cd cman; ./configure --ccsincdir=${TOPDIR}/ccs/lib --ccslibdir=${TOPDIR}/ccs/lib --libdir=%{_libdir}  ; cd ..
cd group; ./configure --kernel_src=/usr/ --libdir=%{_libdir} --cmanlibdir=${TOPDIR}/cman/lib; cd ..

%if %{buildxen}
cd fence; ./configure --enable_xen --ccslibdir=${TOPDIR}/ccs/lib --ccsincdir=${TOPDIR}/ccs/lib --cmanincdir=${TOPDIR}/cman/lib --libdir=%{_libdir}; cd ..
%else
cd fence; ./configure --ccslibdir=${TOPDIR}/ccs/lib --ccsincdir=${TOPDIR}/ccs/lib --cmanincdir=${TOPDIR}/cman/lib --libdir=%{_libdir}; cd ..
%endif

ls -l /usr/lib/
ls -l /

for dir in ccs cman dlm fence group; do
  cd $dir
  sed -i '/RELEASE_MAJOR/s/= .*/= %{cman_major}/' make/defines.mk
  sed -i '/RELEASE_MINOR/s/= .*/= %{cman_minor}/' make/defines.mk
  sed -i '/RELEASE /s/= .*/= %version/' make/defines.mk
  cd ..
done


for dir in 'cman/lib' ccs cman dlm group fence; do
  cd $dir
  make
  cd $TOPDIR
done

%install
TOPDIR=`pwd`
rm -rf $RPM_BUILD_ROOT
for dir in ccs cman dlm fence group; do
  cd $dir
  make install DESTDIR=$RPM_BUILD_ROOT
  cd $TOPDIR
done

mkdir -p $RPM_BUILD_ROOT/etc/rc.d
mv -f $RPM_BUILD_ROOT/etc/init.d $RPM_BUILD_ROOT/etc/rc.d/
mkdir -p $RPM_BUILD_ROOT/var/run/cluster
mkdir -p $RPM_BUILD_ROOT/etc/cluster

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add cman
/sbin/chkconfig --add scsi_reserve
/sbin/chkconfig --add qdiskd

%preun
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del cman
	/sbin/chkconfig --del scsi_reserve
	/sbin/chkconfig --del qdiskd
fi

%files
%defattr(-,root,root,-)
/sbin/*
/usr/sbin/*
/etc/rc.d/init.d/*
/usr/libexec/*
%{_libdir}/*.so*
%{_mandir}/*/*
%dir /var/run/cluster
%dir /etc/cluster

%files devel
%defattr(-,root,root,-)
/usr/include/*
%{_libdir}/*.a

%changelog
* Mon Apr  9 2007 Chris Feist <cfeist@redhat.com> - 2.0.62-1
- Resolves: rhbz#234888

* Tue Jan 23 2007 Chris Feist <cfeist@redhat.com> - 2.0.60-1
- fence_tool now times out after 300 seconds
- Resolves: rhbz#222933

* Tue Jan 16 2007 Chris Feist <cfeist@redhat.com> - 2.0.59-1
- New upstream sources
- Resolves: rhbz#222744 rhbz#222838 rhbz#222686  

* Mon Jan 15 2007 Chris Feist <cfeist@redhat.com> - 2.0.58-1
- New upstream sources
- Resolves: rhbz#221629  

* Thu Dec 21 2006 Chris Feist <cfeist@redhat.com> - 2.0.57-1
- New upstream sources
- Resolves: rhbz#218560  

* Mon Dec 18 2006 Chris Feist <cfeist@redhat.com> - 2.0.56-1
- New upstream sources.
- Resolves: rhbz#218551

* Mon Dec 18 2006 Chris Feist <cfeist@redhat.com> - 2.0.55-1
- New upstream sources.
- Resolves: rhbz#216954 rhbz#219878

* Fri Dec 15 2006 Chris Feist <cfeist@redhat.com> - 2.0.52-1
- New upstream sources.
- Resolves: rhbz#217724

* Thu Dec 14 2006 Chris Feist <cfeist@redhat.com> - 2.0.51-1
- New upstream sources.
- Resolves: rhbz#218688 rhbz#219385

* Tue Dec 05 2006 Chris Feist <cfeist@redhat.com> - 2.0.49-1
- New upstream sources.
- Resolves: rhbz#216052 rhbz#215962

* Tue Dec 05 2006 Chris Feist <cfeist@redhat.com> - 2.0.46-1
- New upstream sources.
- Resolves: rhbz#214540 rhbz#218103

* Wed Nov 29 2006 Chris Feist <cfeist@redhat.com> - 2.0.44-1
- New upstream sources.
- Resolves: rhbz#213878 rhbz#216902 rhbz#213763 rhbz#217436
- Resolves: rhbz#217460 rhbz#211836 rhbz#211918

* Mon Nov 13 2006 Chris Feist <cfeist@redhat.com> - 2.0.38-1
- New upstream sources with fixes for fence_xvmd (bz #212474)

* Thu Nov 09 2006 Chris Feist <cfeist@redhat.com> - 2.0.35-2
- New upstream sources with join_timeout and consensus_timeout
  set to high defaults (bz #214290)

* Mon Nov 06 2006 Chris Feist <cfeist@redhat.com> - 2.0.34-1
- New upstream sources.

* Fri Nov 03 2006 Chris Feist <cfeist@redhat.com> - 2.0.33-2
- New upstream sources.

* Fri Oct 27 2006 Chris Feist <cfeist@redaht.com> - 2.0.30-3
- Create and own /etc/cluster (bz #212582)

* Wed Oct 25 2006 Chris Feist <cfeist@redhat.com> - 2.0.30-1
- New upstream sources.

* Mon Oct 23 2006 Chris Feist <cfeist@redhat.com> - 2.0.29-1
- New upstream sources.

* Wed Oct 18 2006 Chris Feist <cfeist@redhat.com> - 2.0.28-4
- Build without xen deps.

* Mon Oct 16 2006 Chris Feist <cfeist@redhat.com> - 2.0.28-1
- New upstream sources

* Fri Oct 13 2006 Chris Feist <cfeist@redhat.com> - 2.0.25-1
- New upstream sources

* Thu Oct 12 2006 Chris Feist <cfeist@redhat.com> - 2.0.23-2
- New upstream sources
- Fixed init scripts

* Tue Oct 10 2006 Chris Feist <cfeist@redhat.com> - 2.0.22-1
- New upstream sources

* Thu Oct 5 2006 Chris Feist <cfeist@redhat.com> - 2.0.21-1
- New upstream sources
- Build w/ xen deps for fence-xen

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 2.0.18-2
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Mon Sep 25 2006 Chris Feist <cfeist@redhat.com> - 2.0.18-1
- New upstream sources

* Tue Sep 19 2006 Chris Feist <cfeist@redhat.com> - 2.0.17-1
- New upstream sources

* Mon Sep 18 2006 Chris Feist <cfeist@redhat.com> - 2.0.16-1
- New upstream sources

* Thu Sep 14 2006 Chris Feist <cfeist@redhat.com> - 2.0.15-1
- New upstream sources

* Wed Sep 13 2006 Peter Jones <pjones@redhat.com> - 2.0.14-4
- Don't activate the service by default, since it won't be configured

* Wed Sep 13 2006 Chris Feist <cfeist@redhat.com> - 2.0.14-2
- Rebuild w/ new upstream sources
- Remove libxml deps

* Thu Aug 31 2006 Chris Feist <cfeist@redhat.com> - 2.0.13-1
- Rebuild w/ new upstream sources

* Fri Aug 25 2006 Chris Feist <cfeist@redhat.com> - 2.0.12-1
- Rebuild w/ new upstream sources

* Tue Aug 22 2006 Chris Feist <cfeist@redhat.com> - 2.0.11-1
- Rebuild w/ new upstream sources

* Wed Aug 16 2006 Chris Feist <cfeist@redhat.com> - 2.0.10-1
- Rebuild w/ new upstream sources

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 2.0.9-0
- Rebuild w/ new upstream sources

* Fri Aug 11 2006 Chris Feist <cfeist@redhat.com> - 2.0.8-0
- Rebuild w/ new upstream sources

* Thu Aug 10 2006 Chris Feist <cfeist@redhat.com> - 2.0.7-0
- Rebuild w/ new upstream sources

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com>
- rebuild

* Thu Jul 06 2006 Chris Feist <cfeist@redhat.com> - 2.0.1-0.fc6.0
- Rebuild w/ new upstream sources

* Wed Mar 01 2006 Chris Feist <cfeist@redhat.com> - 2.0.0-0.fc6.4
- Rebuilt w/ new upstream sources

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1.0.4-0.FC5.1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 16 2005 Chris Feist <cfeist@redhat.com>
- Rebuilt w/ new upstream sources

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Tue Jul 05 2005 Chris Feist <cfeist@redhat.com>
- Added libraries and cman-devel package

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Require cman-kernel-modules.

* Thu May 05 2005 Chris Feist <cfeist@redhat.com>
- Added patch to disable starting up the init scripts.

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Rebuild with new sources.

* Mon Dec 13 2004 Chris Feist <cfeist@redhat.com>
- Rebuild with new sources.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Fri Oct 22 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- update the requirements field

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- add man pages

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- build for i386 and x86_64 only

* Tue Jul 13 2004 Jon Brassow <jbrassow@redhat.com> 
- New upstream sources

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
